import styles from './_App.scss';

import React from 'react';
import AppActions from '../../actions/AppActions.js';
import ItemsStore from '../../stores/ItemsStore.js';
import Body from '../Body/Body.js';

function getAppState() {
  return {
    items: ItemsStore.getAll()
  };
}

export default class App extends React.Component {

  state = getAppState();

  componentDidMount() {
    ItemsStore.addChangeListener(this.onChange);
    AppActions.getItems();
  }

  componentWillUnmount() {
    ItemsStore.removeChangeListener(this.onChange);
  }

  onChange = () => {
    this.setState(getAppState());
  };

  render() {
    return React.createElement(
      'div',
      { className: styles.app },
      React.createElement(Body, { items: this.state.items })
    );
  }
}
